import pygame
import random

pygame.init()
screen = pygame.display.set_mode((500, 1000))
pygame.display.set_caption('飞机大战')

rand2 = random.randint(0, 1)
if rand2:
    bg = pygame.image.load('背景b.png')
else:
    bg = pygame.image.load('背景a.png')
texts = [['666', '牛bai', '牛到不行'], ['what the matter???', '就你手贱', '6的嘞', 'What??????????', '你是猪吗?']]
plane = pygame.image.load('主角1.png')
plane2 = pygame.image.load('主角2.png')

enemy1 = pygame.image.load('敌机1.png')
enemy2 = pygame.image.load('敌机2.png')
enemy3 = pygame.image.load('敌机3.png')
big_enemy = pygame.image.load('大飞机.png')
boss_enemy = pygame.image.load('大导弹.png')
enemys = [enemy1, enemy2, enemy3, big_enemy, boss_enemy]
create_enemy = []

bullet_img = pygame.image.load('子弹1.png')
bullet2_img = pygame.image.load('子弹2.png')
create_bullet = []

gameover_img = pygame.image.load('游戏结束.png')

bg_y = 0
plane_x = 200
plane_y = 800
plane2_x = 200
plane2_y = 1000

clock = pygame.time.Clock()
f = 0
bg_speed = 1

bgm = pygame.mixer.Sound('紧张背景音乐.mp3')
shot = pygame.mixer.Sound('射击音效.mp3')
explosion = pygame.mixer.Sound('爆炸音效.mp3')
gameover_sound = pygame.mixer.Sound('主角被撞.mp3')

bgm.play(loops=-1)
font = pygame.font.Font('SimHei.ttf', 30)
score = 0
gameover = False
good = texts[0][random.randint(0, 2)]
bad = texts[1][random.randint(0, 3)]
while True:
    n = random.randint(1, 100)
    if n == 1:
        e = random.choice(enemys)
        create_enemy.append({
            '图片': e,
            'x': random.randint(0, 250),
            'y': -100,
            '速度': random.randint(2, 5),
            '删除': 0,
            '血量': 5,
        })
    bg_y += bg_speed
    if bg_y >= 1000:
        bg_y = 0
    events = pygame.event.get()
    keys = pygame.key.get_pressed()
    mouse_pos = pygame.mouse.get_pos()
    mouse = pygame.mouse.get_pressed()
    plane_x = mouse_pos[0] - 50
    plane_y = mouse_pos[1] - 40
    if keys[pygame.K_w] and plane2_y > 0:
        plane2_y -= 5
    if keys[pygame.K_s] and plane2_y < 920:
        plane2_y += 5
    if keys[pygame.K_a] and plane2_x > 0:
        plane2_x -= 5
    if keys[pygame.K_d] and plane2_x < 400:
        plane2_x += 5
    if mouse[0] or keys[pygame.K_SPACE]:
        if gameover == False and f == 0:
            shot.play()
            create_bullet.append({
                '图片': bullet_img,
                'x': plane_x + 35,
                'y': plane_y,
                '速度': bg_speed - bg_speed * 2,
                '删除': 0
            })
        f += 1
        if f == 20:
            f = 0
    else:
        f = 0
        
    screen.blit(bg, (0, bg_y))
    screen.blit(bg, (0, bg_y - 1000))
    
    for e in events:
        if e.type == pygame.QUIT:
            exit()
    for enemy in create_enemy:
        enemy['y'] += enemy['速度']
        screen.blit(enemy['图片'], (enemy['x'], enemy['y']))
        if enemy['y'] > 1000:
            enemy['删除'] = 1
    for bullet in create_bullet:
        bullet['y'] += bullet['速度']
        screen.blit(bullet['图片'], (bullet['x'], bullet['y']))
        if bullet['y'] < -40:
            bullet['删除'] = 1
    for bullet in create_bullet:
        for enemy in create_enemy:
            if bullet['x'] + 30 > enemy['x'] and bullet['x'] < enemy['x'] + 150:
                if bullet['y'] < enemy['y'] + 100 and bullet['y'] + 40 > enemy['y']:
                    explosion.play()
                    bullet['删除'] = 1
                    enemy['血量'] -= 1
                    if enemy['血量'] == 0:
                        enemy['删除'] = 1
                        score += 1
    for i in create_enemy:
        if plane_x > i['x'] - 60 and plane_x < i['x'] + 120:
            if plane_y > i['y'] - 80 and plane_y < i['y'] + 100:
                if gameover == False:
                    gameover_sound.play()
                gameover = True

    if gameover:
        screen.blit(gameover_img, (100, 400))
    else:
        screen.blit(plane, (plane_x, plane_y))
        screen.blit(plane2, (plane2_x, plane2_y))
    
    word = font.render('分数:{}'.format(score), True, (255, 0, 0))
    if gameover:
        over = font.render('状态：已嗝屁({})'.format(bad),True,(255, 0, 0))
    else:
        over = font.render('状态：未嗝屁({})'.format(good),True,(255, 0, 0))
    if bg_speed > 120:
        go = font.render('您已超速, 时速: {}'.format(round(bg_speed, 2)), True, (255, 0, 0))
    if bg_speed > 160:
        bg_speed = 50
    if bg_speed < 120:
        go = font.render('您未超速, 时速: {}'.format(round(bg_speed, 2)), True, (255, 0, 0))
    screen.blit(go, (0, 60))
    screen.blit(word, (0,0))
    screen.blit(over, (0, 30))
    ls = []
    for enemy in create_enemy:
        if enemy['删除'] == 0:
            ls.append(enemy)
    create_enemy = ls
    ls = []
    for bullet in create_bullet:
        if bullet['删除'] == 0:
            ls.append(bullet)
    create_bullet = ls
    pygame.display.flip()
    clock.tick(60)
    if not(gameover):
        bg_speed += 0.01